<%--
 Component: qr

 Description:
  Web interface for Query/Retrieve client

--%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="java.util.*,java.io.*, imagemed.imsession.*,imagemed.util.*,
			imagemed.tables.*, imagemed.imtables.*,imagemed.jsputil.*,imagemed.http.*,
			imagemed.lists.*"

%><%!
String nonCustomizedListParam( IMRequest parReq ) {
	String list = parReq.getVal( "cList_" + ListType.QR.getIndex() );
	if ( list != null ) {
		// a list has to be sent to the filters page before executing
		return "&cList_" + ListType.QR.getIndex() + "=" + Helper.URLEncodeUTF8( list );
	}
	// is it a default list?
	if ( parReq.getVal( "cFields" ) == null ) {
		return ""; // that should go through the filters page as well
	}
	// we have a custom view, proceed displayin git
	return null;
}
%><%
	IMSession is = new IMSession(request, response, out); 
	if (!is.regOK()) {
		return;
	}
	
	IMRequest parReq = is.imRequest;

	String nclp = nonCustomizedListParam(parReq);
	if ( nclp != null ) {
		response.sendRedirect( "/cases/dcfilterb.jsp?cIndexPage=/qr/index.jsp&cIndexTab=QR&addListSelector=" + ListType.QR.getIndex() + nclp );
		return;
	}

	String parHost = QRToolbox.getcurrentQRHost(parReq);

	String context = parReq.m_context;
	if (context == null) {
		context = parReq.backupContext();
	}
	parReq.passAsFile(context);
	
%><%!
	String strValidLevels = "|PATIENT|STUDY|SERIES|IMAGE|";
%><%
	String thisPage = "/qr/index.jsp";

	String defaultFields[] = TableParams.getDefaultFields(thisPage, is);
	String sort[]          = TableParams.getDefaultSorts(thisPage);
	String extraParams[]   = { "qrHost", "mvHost", "cInfModel" };
	Properties defFilters  = TableParams.getDefaultFilters(thisPage, is);

	String parFields[]    = parReq.getVals("cFields");

	boolean needSetDefaultFilter = parHost == null && parFields == null;

	Properties prpConfig = new Properties();

	try {
		prpConfig.load(new FileInputStream(IMEnvBase.getEnv("CONF") + "/qrclient.cfg"));
	}
	catch(Throwable th) {}

	String strLevel=parReq.getVal("cLevel");

	if (strLevel == null || -1 == strValidLevels.indexOf("|" + strLevel + "|")) {
		strLevel = prpConfig.getProperty("Level","Study").toUpperCase();
	}
	if (-1 == strValidLevels.indexOf("|" + strLevel + "|")) {
		strLevel = "STUDY";
	}

	// out.println(strInfModel+"/"+strModel+"/"+strLevel);

	TableDescriptor tdesc = new TableDescriptor(thisPage);
	TableProperties tprop = new TableProperties();
	
	WorklistTableParams tparams = new WorklistTableParams( is, is.getProfileUser(), is.regRights.indexOf('A') > -1, is.isRegisteredViewer());  
	tparams.setDefaultFields(defaultFields);
	tparams.setDefaultSort(sort);
	tparams.setDefaultPage(1);
	if (needSetDefaultFilter) {
		tparams.setDefaultFilters(defFilters);
	}
	tparams.setDefaultPageSize(20);
	tparams.setExtraParams(extraParams);

	tdesc.setTableParams(tparams);
	tdesc.setTableProperties(tprop);
	tdesc.setSortDepth(3);

//	IMFieldManager fm = (IMFieldManager) new IMDCMFieldManager("Dcfields", "Dctypes", "QR");
//	fm.setFilterMode(IMFieldManager.Q_R);

//	tdesc.setFieldManager(fm);

	tdesc.setFieldManager(new ArchivesFieldManager( ArchivesFieldManager.MODE.QR_ARCHIVES, ArchivesFieldManager.ISSUER.LOCAL ) );

//	String linkPrefix = "/qr/retrieve.jsp?qrHost=" + Helper.URLEncode(parHost == null ? "" : parHost);

	Action act[] = new Action[2];
	act[0] = new ArchiveCheckbox(tprop, true);
//	act[0] = (Action) new CheckboxAction(tprop, "SYUI", "cGr", null);
	act[1] = new ComboAction(tdesc, ComboAction.TYPE_QR, "rm");


	Action batchAct[] = new Action[2];
	batchAct[0] = new LinkAction(tdesc, null, "JavaScript:Batch_(\"Get\")",
			"<IMG SRC=\"/cases/art/get.gif\" width=\"16\" height=\"20\"" +
			" alt=\"Get selected studies\" border=0>",
			"Get selected studies");
	
	batchAct[1] = new LinkAction(tdesc, null, "JavaScript:Batch_(\"Move\")",
			"<IMG SRC=\"/cases/art/forward.gif\" width=\"16\" height=\"20\"" +
			" alt=\"Move selected studies\" border=0>",
			"Move selected studies");
	
	Column col = new Column(new BatchHeader(batchAct), new ActionCell("SYUI", act), "SYUI"); 
	tdesc.addExtraColumn("_FIRST",col);

	List<TopCell> topCell = new Vector<TopCell>();
	topCell.add( new ListsTopCell( ListType.QR, tdesc, is.getProfileUserId(), true) );
	topCell.add( new TitleTopCell(tprop, "Query/Retrieve") );
	topCell.add( new FieldsTopCell(tdesc, null, false) );
	topCell.add( new FiltersTopCell(tdesc, null, false, new String[0], false) );
	topCell.add( new SortsTopCell(tdesc, null, false, false) );
	topCell.add( new PageTopCell(tprop, tparams) );

	tdesc.setTopCells(topCell);

	
	ArchivesResult result = new ArchivesResult( tdesc, null, StudyToolbox.getOwnerHUB( is, null ), false );
	result.setRequiredFields( new String[] {"SYUI", "RSRC", "REAE"} );
	
	String resultID = result.getResultID();

	if (resultID != null && !resultID.equals(parReq.getVal("cResultID"))) {
		parReq.setProperty("cResultID", resultID);
		parReq.passAsFile(parReq.m_context);
	}
		
	
	tdesc.setResult(result);

	Table table = new Table(tdesc);

//	boolean isCancelled = result.isCancelled();
//	boolean isCancelled = false;

%><%!

//	boolean isHostSelected(String host, String selectedHosts[]) {
//		boolean bSelected = false;
//		if (selectedHosts != null) {
//			for (int i=0; i<selectedHosts.length; i++) {
//				bSelected = host.equals(selectedHosts[i]);
//				if (bSelected) {
//					break;
//				}
//			}
//		}
//		return bSelected;
//	}

	String noPassAtAll = "r_setc,cFields";

%><HTML>
 <HEAD><TITLE>Query/Retrieve</TITLE>
 <SCRIPT Language="JavaScript">
   var pageContext="<%=context%>";
 </script>
<%
	TabToolbox.writeIMpopup(out);
	table.printScript(tparams, is, new String[] {ArchiveCheckbox.CHECKBOXNAME});
%>
  <SCRIPT language="JavaScript">

		function Batch_(pOper) {
			if (pOper == 'Move') {
				self.document.Batch.action = '/qr/retrieve.jsp';
			}
			else {
				self.document.Batch.action = '/archive/get.jsp';
			}

			self.document.Batch.submit();
		}


		function submitQuery(frm) {
			frm.submit();
		}

		function forceRetrieve(device, study) {
			text="This study is already being retrieved.\nAre you sure you want to start a new retrieve operation?";
			if (confirm(text)) {
				document.location="/archive/get.jsp?cDevStudy="+device+"+"+study+"&cForced=true";
			}
		}

		function submitRetrieve(frmhosts,frmstudies) {
			var str = "";
			for (i = 0 ; i < frmstudies.elements.length; i++) {
				if (frmstudies.elements[i].checked) {
					str = str + "\n" + frmstudies.elements[i].value;
				}
			}
			frmhosts.mvStudies.value = str.substring(1,str.length);
			frmhosts.submit();
		}
  </SCRIPT>

  </HEAD>
  <BODY>
<%

	TabToolbox.makeTabs( is, is.tabbean, "qr/index.jsp", "White");

	try {
		table.printTableTop(is);
	}
	catch (Throwable th) {
		Helper.DEBUG("qr/index.jsp", Helper.throwable2String(th));
	}

%><%--
<TABLE border=1 cellpadding=0 cellspacing=0 width=100%>
  <tr>
   <td class=BgShadow width=100% valign=top>
   <table border=0 width=100%><tr>
    <FORM action="<%=thisPage%>" name=queryForm>
    <INPUT type="hidden" name="cPage" value="1">
    <INPUT type="hidden" name="cContext" value="<%=context%>">
    <td align=left><%=QRSelectorFormPart.getSelector(true, parHost)%></td>
    <TD align=center>
    </td><td align=right>
<%
	if (isCancelled) {
%><FONT COLOR="#ff0000" SIZE=+1><blink>TRANSFER CANCELLED</blink></font><BR><BR>
<FONT COLOR="#ff0000"> Only partial results are displayed: use stricter filters</font><%
	}
%>
     </td>
     </tr>
     </FORM>
     </table>
   </td>
   </tr>
   <!-- INPUT TYPE=HIDDEN NAME=mvStudies VALUE="" -->
   </FORM>
   </table>
   </td>
  </tr>
</table>

--%><%-- FORM name=studiesForm --%>
<%
	try {
		table.printTableWithoutPageNavigation(is);
		
		//SZEDDKI
		Helper.writeTextFile( "/home/medsrv/tmp/archiveresult", result.getDebug() );
	}
	catch (Throwable th) {
	}
%>
<%-- /FORM --%>

<%
	try {
		table.printPageNavigation(is);
	}
	catch (Throwable th) {
	}
%>

<%-- = "<pre>"+result.getDebug()+"</pre>" --%>
<%=ListSaveForm.getListSaveForm( ListType.QR, is, tdesc)%>

</CENTER>
</BODY></HTML>
